#include <stdio.h>
#include <ctype.h>
#include <unistd.h>

#include "xhw_types.h"
#include "xhw_memmap.h"
#include "xcore.h"
#include "xsysctl.h"
#include "xgpio.h"
#include "xwdt.h"
#include "xuart.h"

#include "segedlet.h"

int v= 0;
volatile int lcnt= 0, pcnt= 0;
volatile unsigned int clk= 0;

void SysTickIntHandler(void)
{
  clk++;
}

unsigned int last= 0;
unsigned int blink_time= 500;

void blink()
{
  if (clk-last > blink_time)
    {
      last= clk;
      v= !v;
      red_toggle();
    }
}

unsigned int last_msg= 0;

void msg()
{
    if (clk-last_msg > 2000)
      {
        last_msg= clk;
        printf("%u ", clk);
        fflush(stdout);
      }
}

int lp= 0, lr= 0;

int main(void)
{
  int steps, duty= 50;

  board_init();
  systick_init(0.001);
  uart_init();
  tsi_init();
  tsi_start();
  steps= blue_pwm(1000, duty);
  //xSysCtlPeripheralEnable(xSYSCTL_PERIPH_PWMA);
  //xHWREG(PWMA_BASE+TPM_SC)= 8;

  //while (1)	UARTCharPut(UART0_BASE, 0x55);
  if (steps > 0xffff)
    printf("PWM frq too low\n");
  while(1)
    {
      volatile int v= xHWREG(PWMA_BASE+TPM_CNT);
      if (uart_avail())
        {
          char c;
          unsigned int cv;
          read(0, &c, 1);
          printf("%c", (isprint((int)c)||(c=='\n')||(c=='\r'))?c:'?');
          if (c == 's')
            {
              printf("\nsteps= %d\n", steps);
              printf("clock src= %08lx\n", xHWREG(0x40048004));
            }
          if (c=='v')
            printf("\nv= %d\n", v);
          if (c=='+')
            {
              if ((duty= duty*2) > 100)
                duty= 100;
              if (duty==0)
                duty= 1;
              steps= blue_pwm(1000, duty);
              cv= xHWREG(PWMA_BASE+TPM_C1V);
              printf("\nsteps= %d/cv= %u (duty=%d)\n", steps, cv, duty);
            }
          if (c=='-')
            {
              if ((duty= duty/2) < 0)
                duty= 0;
              steps= blue_pwm(1000, duty);
              cv= xHWREG(PWMA_BASE+TPM_C1V);
              printf("\nsteps= %d/cv= %u (duty=%d)\n", steps, cv, duty);
            }
          fflush(stdout);
        }
      if (tsi_done())
        {
          tsi_get();
          tsi_start();
    	  //printf("\nraw=%d val=%d lp=%d lr=%d\n", tsi_raw, tsi_value, lp, lr);
        }
      if (tsi_touched())
        {
    	  //blink_time= 50+tsi_value*10;
    	  printf("\ntsi=%d\n", tsi_flt_val);
    	  blink_time= lp= tsi_flt_val;
        }
      if (tsi_released())
      {
    	  lr= tsi_flt_val;
      }

      if (tsi_touch())
        {
          green_on();
          //blink_time= 50+tsi_flt_val*10;
        }
      else
        {
          green_off();
          //blink_time= 500;
        }
      blink();
      msg();
    }
}
